# FORCE_EFI_BOOT

echo -off
# +
# + ============================================================== +
#  Copyright (c) 2022, Intel Corporation.

#  This source code and any documentation accompanying it ("Material") is furnished
#  under license and may only be used or copied in accordance with the terms of that
#  license.  No license, express or implied, by estoppel or otherwise, to any
#  intellectual property rights is granted to you by disclosure or delivery of these
#  Materials.  The Materials are subject to change without notice and should not be
#  construed as a commitment by Intel Corporation to market, license, sell or support
#  any product or technology.  Unless otherwise provided for in the license under which
#  this Material is provided, the Material is provided AS IS, with no warranties of
#  any kind, express or implied, including without limitation the implied warranties
#  of fitness, merchantability, or non-infringement.  Except as expressly permitted by
#  the license for the Material, neither Intel Corporation nor its suppliers assumes
#  any responsibility for any errors or inaccuracies that may appear herein.  Except
#  as expressly permitted by the license for the Material, no part of the Material
#  may be reproduced, stored in a retrieval system, transmitted in any form, or
#  distributed by any means without the express written consent of Intel Corporation.

#  Module Name:  FWVerCheck.nsh

#  Abstract:  UEFI Script file for invoking system software updates for 
#  Intel(R) Server Board M50CYP Family.

# + ============================================================== +

@echo -off
mode 80 25
:foundimage section is simply to locate the correct drive

if exist .\ipmi.efi then
 goto FOUNDIMAGE
endif
if exist fs0:\ipmi.efi then
 fs0:
 echo Found Update Packages on fs0:
 goto FOUNDIMAGE
endif
if exist fs1:\ipmi.efi then
 fs1:
 echo Found Update Packages on fs1:
 goto FOUNDIMAGE
endif
if exist fs2:\ipmi.efi then
 fs2:
 echo Found Update Packages on fs2:
 goto FOUNDIMAGE
endif
 echo "Unable to find Update Packages".  
 echo "Please mount the drive with the update package".
 echo ""
 goto END
:FOUNDIMAGE

#get current version info.
echo "Reading Current FW version..."
sysfwupdt.efi -i > CurrentSysFwVersions.tmp 
cat CurrentSysFwVersions.tmp
stall 5000000
cmdtool.efi 20 c0 bb > CurrentCPLDVersion.tmp 
ipmctl.efi show -dimm > CurrentPmemVersion.tmp


grepX64.efi CurrentCPLDVersion.tmp  "00 00 02 0A 03" grepCPLD.tmp * -line
if %lasterror% == "0" then
    echo " "
    echo "Skip the same version CPLD firmware update."
    echo "CPLD Updated" > CPLD_pass.tmp

else
    echo "CPLD firmware need to be updated."

endif


grepX64 CurrentSysFwVersions.tmp "SE5C620.86B.01.01.0005" grepBIOS.tmp * -line                                  
if %lasterror% == "0" then         
echo " "
    echo "Skip the same version BIOS firmware update."
    echo "BIOS Updated" > BIOS_pass.tmp
else
    echo "BIOS firmware need to be updated."
endif 

grepX64 CurrentSysFwVersions.tmp "2.88.e5f45b9c" grepBMC.tmp * -line
if %lasterror% == "0" then
    echo " "
    echo "Skip the same version BMC firmware update."
    echo "BMC Updated" > BMC_pass.tmp
else
    echo "BMC firmware need to be updated."
endif

grepX64 CurrentSysFwVersions.tmp "SDR Package 0.40" grepSDR.tmp * -line
if %lasterror% == "0" then
    echo " "
    echo "Skip the same version SDR firmware update."
    echo "SDR Updated" > FRUSDR_pass.tmp
else
    echo "SDR firmware need to be updated."
endif

comp noPmem.log CurrentPmemVersion.tmp > comp.tmp
if %lasterror% == 0 then
	echo " "
	echo "No Pmem DIMM installed, ignoring Pmem FW Update" > Pmem_pass.tmp
else
grepX64 CurrentPmemVersion.tmp "02.02.00.1553" grepPmem.tmp * -line
if %lasterror% == "0" then
    echo " "
    echo "Skip the same version Pmem firmware update."
    echo "Pmem Updated" > Pmem_pass.tmp
else
    echo "Pmem firmware need to be updated."
    endif
endif

rm grep*.tmp > nul
rm CurrentPmemVersion.tmp > nul
rm CurrentCPLDVersion.tmp > nul
rm CurrentSysFwVersions.tmp > nul 
#rm BMC_pass.tmp > nul
#rm FRUSDR_pass.tmp > nul
#rm Pmem_pass.tmp > nul
#rm BIOS_pass.tmp > nul
:END
 